
/* Esercizio 2 di Esercizidel31-5-17
La classe MuQueueADTX non pone vincoli sulla dimensione delle code 
n\`e sugli oggetti che possono accedere. In particolare permette 
code con pi\`u occorrenze di uno stesso oggetto A.
Si specializzi la classe MuQueueADTX in una nuova classe per code 
Polimorfe, Mutable a presenza singola che non ammetta occorrenze
multiple.
Si chiede di:
 (a) Definire un ADT, MuQSingleADTX che specializzi MuQueueADTX
     aggiungendo tale propriet\`a
 (b) Fornire gli additionals per MuQSingleADTX
 (c) Fornire AF e I  per MuQSingleADTX; 
 (d) Fornire, compilare ed eseguire un caso di uso.
 */

import java.util.*;
import java.lang.*;

/* (a,b) */
public class MuQSingleADTX<A> extends MuQueueADTX<A>{
    private Vector<A> occ;
	//metodi
	public MuQSingleADTX(){
		super();
        occ = new Vector<A>();
	}
    public void add(A x){
        if (occ.contains(x)) return;
        occ.add(x);
        super.add(x);
    }
	//public A get() -- inherited
	public void remove(){
        A out = get();
        super.remove();
        occ.remove(out);
	}
	//public int size() -- inherited
	//public boolean empty() -- inherited
	
	//additionals
	//equals ereditata da Object
	public MuQSingleADTX<A> clone(){//it computes subtypes
		MuQSingleADTX<A> ret = (MuQSingleADTX<A>) super.clone();
		ret.occ = (Vector<A>)occ.clone();
        return ret;
	}
	//public String toString() -- inherited
	//public LinkedList<A> elements() -- inherited
}

/* (d)
 Sia [MuQSingleADTX<A>]={[v1,...,vk] | (forall i\[1..k]) vi\in[Ta], Ta\in[A]},
 l'insieme dei valori astratti definiti da MuQueueADTX<Ta>, dove v1 e' first 
 ed e' il primo elemento inserito e non rimosso.
 AF(c) = AF[c.super]
 In effetti il valore espresso \`e definito dallo stato del super_oggetto.
 Per l'invariante invece, oltre a soddisfare l'invariante della super (come \`e
 ovvio), qui abbiamo alcune ulteriori propriet\`a:
 I(c) = c.occ.contains(x) iff elements().contains(x)
	& forall i,j\in[0..elements.size()-1], 
				 i!=j iff !(element.get(i).equals(element.get(j))
 */

 
