
/* Esercizio 1 di Esercizidel30-5-17 
 Una queue e' un valore con le seguenti operazioni specifiche:
	add per aggiungere un elemento alla coda
	get per accedere il primo tra gli inseriti, non ancora rimossi
	remove per rimuovere il primo tra gli inseriti, non ancora rimossi
	size per conoscere quanti elementi sono ancora in coda
	empty per conoscere se la coda ha elementi
 Si chiede di:
 (a) Introdurre in Java, un API per un tipo astratto per queue polimorfe
	 Modificabili
 (b) Definire un ADT, MuQueueADT.java, per tale API;
 (c) Definire gli additionals
 (d) Fornire AF e I  per MuQueueADT.java;
 (e) Definire un caso di uso ed applicare mostrando cosa produce 
	 l'esecutore
 (f) Provare la correttezza di I.
 */

import java.util.*;
import java.lang.*;

class Error extends RuntimeException{
}

/* (a,b,c) */
interface MuQueueAPI<A> extends Cloneable{
    public void add(A x);
    public A get();
    public void remove();
	public int size();
    public boolean empty();
}

public class MuQueueADTX<A> implements MuQueueAPI<A>{
	private A first;
    private MuQueueADTX<A> rest;
	private int size;
	//metodi
	public MuQueueADTX(){//for introducing empty queue
		size = 0;
	}
	public void add(A x){//caratteristica di queue vs stack
		if (first == null){first = x; size = 1; return;}
		if (rest == null) rest = new MuQueueADTX<A>();
        rest.add(x);
		size = size+1;
	}
	public A get(){//restituisce null se vuota
		return first;
	}
	public void remove(){
		if (size == 0) throw new Error();
		size = size - 1;
		if (size > 0){
			first = rest.get();
			rest.remove();
			return;
		}
		first = null;		
	}
	public int size(){		
		return size;
	}
	public boolean empty(){		
		return (size == 0);
	}
	
	//additionals
	//equals ereditata da Object
	
	public MuQueueADTX<A> clone(){
		MuQueueADTX<A> ret = new MuQueueADTX<A>();
		try {ret = (MuQueueADTX<A>) super.clone();
		}catch (Exception e) {}
		ret.first = first;
		ret.rest = (rest==null)?null:rest.clone();
		ret.size = size;
		return ret;
	}
	public String toString(){
		if (size == 0) return "[]";
		String first = this.first.toString();
		if (size == 1) return ("["+first+"]");
		String rest = this.rest.toString();
		rest = rest.substring(1,rest.length()-1);
		return ("["+first+","+rest+"]");
	}
	public LinkedList<A> elements(){//wrong: to be modified
		return null;
	}	
}

/* (d)
 Sia [MuQueueADTX<Ta>]={[v1,...,vk] | (forall i\[1..k]) vi\in[Ta], Ta\in[A]}, 
 l'insieme dei valori astratti definiti da MuQueueADTX<Ta>, dove v1 e' first 
 ed e' il primo elemento inserito e non rimosso.
 AF(c) = [] if c.size = 0
 AF(c) = [v1,...,vk] if (c.size = k) & (k > 0) & c.first = v1
						& AF(c.rest) = [v2,...,vk] 
 I(c) = if (size = 0) then (first = null & rest = null)
        & if (size = 1) then (first != null & rest = null)
        & if (size > 1) then size = rest.size+1
 */


/* (e) */
 
class Main{
    public static void main(String[] args) throws Error{
        MuQueueADTX<Integer> queue1 = new MuQueueADTX<Integer>();
		queue1.add(1);
		queue1.add(5);
        System.out.println("queue1.get() = " + queue1.get());
		MuQueueADTX<Integer> queue2 = queue1;
		MuQueueADTX<Integer> clone1 = queue1.clone();
		queue2.add(12);
		System.out.println("queue1 = " + queue1.toString());		
		System.out.println("queue2 = " + queue2.toString());		
		System.out.println("clone1 = " + clone1.toString());
		clone1.remove();
		clone1.remove();
		System.out.println("queue1 = " + queue1.toString());		
		System.out.println("queue2 = " + queue2.toString());		
		System.out.println("clone1 = " + clone1.toString());
		clone1.add(7);
		clone1.add(6);
		System.out.println("queue1 = " + queue1.toString());		
		System.out.println("queue2 = " + queue2.toString());		
		System.out.println("clone1 = " + clone1.toString());
	}
}

/*
 etruria-wifi-217-70:ZcodeMQAX marcob$ cd ..
 etruria-wifi-217-70:JavaSoluzioni marcob$ javac MuQueueADTX.java 
 MuQueueADTXV.java -d ZcodeMQAX/
 etruria-wifi-217-70:JavaSoluzioni marcob$ cd ZcodeMQAX/
 etruria-wifi-217-70:ZcodeMQAX marcob$ java Main
 queue1.get() = 1
 queue1 = [1,5,12]
 queue2 = [1,5,12]
 clone1 = [1,5]
 queue1 = [1,5,12]
 queue2 = [1,5,12]
 clone1 = []
 queue1 = [1,5,12]
 queue2 = [1,5,12]
 clone1 = [7,6]
 etruria-wifi-217-70:ZcodeMQAX marcob$
 */ 

/* (f) to be done */
 
