(*
Esercizio 4 di Esercizidel31-5-17
Analogamente a quanto visto in Esercizio 2, anche il tipo ImQueueADT 
di OCaml per immutable non pone vincoli sulla dimensione delle code ne' 
sugli oggetti che possono accedere. In particolare permette code con 
pi\`u occorrenze di uno stesso oggetto A.
In Ocaml non possiamo estendere un tipo ed ereditare operazioni dal 
tipo  astratto esteso, tuttavia possiamo fare riuso di codice (anche
se in forma limitata) ricorrendo ad un meccanismo di implementazione:
Implementare il nuovo tipo ricorrendo al tipo che vogliamo estendere.
Si applichi questo alla definizione di un nuovo tipo ImQSingleADT 
con stessa API di ImQueueADT, ma che fornisca code come ImQueueADT
ma aventi singole occorrenze. 
In particolare si chiede di:
 (a) Definire un ADT, ImQSingleADT che specializzi ImQueueADT
     aggiungendo tale propriet\`a
 (b) Fornire gli additionals per ImQSingleADT (clone ed elements)
 (c) Fornire AF e I  per ImQSingleADT; 
*)

open List;;

(* Gi\`a definito: riportato in commento per memo.
exception Error;;
*) 

(* (a) Gi\`a definito: riportato in commento per memo. 
module type IMQUEUE =
sig
	type 'a imQueue
	val make: unit -> 'a imQueue
    val add: 'a * 'a imQueue -> 'a imQueue
    val first: 'a imQueue -> 'a
    val remove: 'a imQueue -> 'a imQueue
    val size: 'a imQueue -> int
    val empty: 'a imQueue -> bool
    val clone: 'a imQueue -> 'a imQueue
    val elements: 'a imQueue -> 'a list
end;;
*)

(* (b,c) *)
module ImSingleADT =
(struct
	type 'a imQueue = {super: 'a ImQueueADT.imQueue; occ: 'a list;}
	let make() = {super = ImQueueADT.make(); occ = [];}
	let rec contains ll e = (* private: only for add *)
		match ll with 
			[] -> false
			| u::ls -> (e = u) || (contains ls e) 		
    let add(e,que) = 
    	 if (contains que.occ e) then que
    	 else {super = ImQueueADT.add(e,que.super); occ = e::que.occ;}
    let first que = ImQueueADT.first(que.super)
    let rec rem ll e = (* private: only for remove *)
		match ll with 
			[] -> []
			| u::ls -> if (e = u) then ls else u::(rem ls e)	    	 
    let remove que = 
    	if (ImQueueADT.size que.super = 0) then que
    	else {super = (ImQueueADT.remove que.super); 
    		  occ = rem que.occ (ImQueueADT.first que.super);}
    let size que = ImQueueADT.size que.super
    let empty que = ImQueueADT.empty que.super    
    (* additionals *)
    let clone que = {super = que.super; occ = que.occ}
	let elements que = ImQueueADT.elements que.super
end:IMQUEUE);;

(* (d)
 Sia [Ta ImSingleADT.inQueue]={[v1,...,vk] | (forall i\[1..k]) vi\in[Ta], Ta\in[A]}, 
 l'insieme dei valori astratti definiti da Ta ImSingleADT.inQueue, dove v1 e' il 
 first ed e' il primo elemento inserito e non rimosso.
 AF(c) = AF(c.super)
 I(c) = (forall i,j\in[0..c.elements().size()-1])
 				i!=j  iff  c.elements().get(i)!=(c.elements().get(j)
*)

(* (e) to be done *)

(* (f)
*)
