(*
Esercizio 3 di Esercizidel31-5-17
 Una queue e' un valore con le seguenti operazioni specifiche:
 	make per creare una coda vuota, i.e. senza elementi
	add per aggiungere un elemento alla coda
	first per accedere il primo tra gli inseriti non ancora rimosso
	remove per rimuovere il primo tra gli inseriti non ancora rimossi
	size per conoscere quanti elementi sono ancora in coda
	empty per conoscere se la coda ha elementi
 Si chiede di:
 (a) Introdurre in OCaml, un API per un tipo astratto per queue poli-
	 morfe Non-Modificabili
 (b) Definire un ADT, ImQueueADT, per tale API;
 (c) Definire gli additionals (clone e elements)
 (d) Fornire AF e I  per ImQueueADT;
 (f) Provare la correttezza di I.
*)

open List;;

exception Error;;

(* (a) *)
module type IMQUEUE =
sig
	type 'a imQueue
	val make: unit -> 'a imQueue
    val add: 'a * 'a imQueue -> 'a imQueue
    val first: 'a imQueue -> 'a
    val remove: 'a imQueue -> 'a imQueue
    val size: 'a imQueue -> int
    val empty: 'a imQueue -> bool
    val clone: 'a imQueue -> 'a imQueue
    val elements: 'a imQueue -> 'a list
end;;

(* (b,c) *)
module ImQueueADT =
(struct
	type 'a maybe = MayBe of 'a | Null
	type 'a imQueue = {first:'a maybe; 
					   rest:('a imQueue) maybe; 
					   size:int}
    let queue0 = {first = Null; rest = Null; size = 0}
	let make () = queue0
    let rec add(e,que) = 
    	match que.first with
    	  Null -> {first = MayBe e; rest = Null; size = 1}
    	  | _ -> (match que.rest with
    	  			Null -> {first = que.first; 
    	                     rest = MayBe (add(e,queue0));
    	                     size = que.size+1}
    	            | MayBe que' -> {first = que.first;
    	            				 rest = MayBe(add(e,que')); 
    	            				 size = que.size+1})	  			
    let first que = match que.first with
    				Null -> raise Error
    				| MayBe e -> e
    let remove que = 
    	match que.first with
    	  Null -> raise Error
    	  | MayBe e -> (match que.rest with
    					  Null -> queue0
    					  | MayBe que' -> que')
    let size que = que.size
    let empty que = (que.size = 0)
    
    (* additionals *)
    let clone que = {first = que.first;
    				 rest = que.rest;
    				 size = que.size}
    let rec elements que = 
    		match que.first with
    			MayBe e -> (match que.rest with
    							MayBe rest -> e :: elements rest
    							| _ -> [e])
    			|_ -> [] 
end:IMQUEUE);;

(* (d)
 Sia [Ta ImQueue.imQueue]={[v1,...,vk] | (forall i\[1..k]) vi\in[Ta], Ta\in[A]}, 
 l'insieme dei valori astratti definiti da Ta ImQueue.imQueue, dove v1 e' il 
 first ed e' il primo elemento inserito e non rimosso.
 AF(c) = [] if c.size = 0
 AF(c) = [v1,...,vk-1,vk] if (c.size = k) & (k > 0) & c.first = v1
                             & AF(c.rest) = [v2,...,vk] 
 I(c) = if (c.size = 0) then (c.first = null & c.rest = null)
    & if (c.size = 1) then (c.first != null & c.rest = null)
    & if (c.size > 1) then c.size = c.rest.size+1
*)

(* (e) to be done *)

(* (f)
*)
